import os.path

data = '''"""
event_name : EVENT_NAME
description : Add Angular libraries to project
config format:

**Place Your Sample configuration here here**

"""
import os
from jennie.rule_engine.events._helper import *

class EVENT_CLASS_NAME():
    def __init__(self, user_key, app_name, type):
        self.user_key = user_key
        self.app_name = app_name
        self.type = type
        
        self.sample_conf = {
            KEY_EVENT_TYPE: EVENT_CONSTANT_NAME
        } # replace with sample configuration.

    def execute(self, event_info):
        """
        :param event: event information
        :return: True / False
        """
        return True

    def build_event(self):
        """
        :return: event_info
        """
        event_info = {
            KEY_EVENT_TYPE: EVENT_CONSTANT_NAME
        }
        return event_info

    def validate(self, event_info):
        """
        Validate Configuration.
        :param event: event info
        :return: event_info / False
        """
        return event_info
'''
EVENTS_FOLDER = "jennie/rule_engine/events"
def add_to_constant_file(import_statement, constant_statement):
    c_start = "# Import event"
    d_start = "# Declare constants"
    _content = open("{}/constants.py".format(EVENTS_FOLDER)).read()
    _init_file = open("{}/__init__.py".format(EVENTS_FOLDER)).read()

    if import_statement not in _init_file:
        _init_file = _init_file.replace(c_start, c_start + "\n" + import_statement)
        print("Added Import -> {}".format(import_statement))

    if constant_statement not in _content:
        _content = _content.replace(d_start, d_start + "\n" + constant_statement)
        print("Declared Constant -> {}".format(constant_statement))

    open("{}/constants.py".format(EVENTS_FOLDER), "w").write(_content)
    open("{}/__init__.py".format(EVENTS_FOLDER), "w").write(_init_file)

def create_event(event_name):
    event_class_name = "event_" + event_name.replace(" ", "_").replace("-", "_")
    event_name = event_name.replace(" ", "-").replace("_", "-")
    import_statement = "from jennie.rule_engine.events.{0} import {0}".format(event_class_name)
    constant = '{0} = "{1}"'.format(event_class_name.upper(), event_name)
    event_content = data.replace("EVENT_NAME", event_name).replace("EVENT_CLASS_NAME", event_class_name).replace("EVENT_CONSTANT_NAME", event_class_name.upper())
    add_to_constant_file(import_statement, constant)
    if not os.path.isfile("events/" + event_class_name + ".py"):
        open("{}/".format(EVENTS_FOLDER) + event_class_name + ".py", "w").write(event_content)
        print ("Event Class Created -> events_{}.py".format(event_class_name))
        print ("\n")
    return True