import json

from jennie.rule_engine.events import ALL_EVENTS
from admin.tests import test_event
from admin.create_events import create_event

class TestEventsInterface():
    def test(self, event_name):
        if event_name not in ALL_EVENTS:
            print ("Event not added in all events")
            return False
        else:
            result = test_event(ALL_EVENTS[event_name]).test
            if result:
                print ("Test Executed:", event_name)
            else:
                print("Some problem occurred")
            return True

    def get_sample_structure(self, event_name):
        return test_event(ALL_EVENTS[event_name]).testclass.sample_conf

    def show_sample_strcuture(self, event_name):
        if event_name not in ALL_EVENTS:
            print("Event not added in all events")
            return False
        else:
            result = test_event(ALL_EVENTS[event_name]).testclass.sample_conf
            if result:
                print("Sample Configuration for event {} : \n\n{}\n\n".format(event_name, json.dumps(result, indent=2)))
            else:
                print("Some problem occurred")
            return True


class AdminInterface():

    def create_main_event(self):
        print("Input no to select from below options")
        options = ["Create Events", "Test Events", "Show Events Info"]
        for option in options:
            print (str(options.index(option) + 1 ) + ". " + option)

        choice = input("Input no between 1 and {} >> ".format(str(len(options))))
        if (choice == "1"):
            return self.create_event()
        elif (choice == "2"):
            return self.test_event()
        else:
            return self.show_event_info()

    def run(self):
        print ("\n\n Admin interface activated....\n\n")
        self.create_main_event()

    def create_event(self):
        event_name = input("Enter Event Name : ")
        create_event(event_name)
        return self.create_main_event()

    def create_events(self, event_names):
        info = []
        for name in event_names:
            info_curr = create_event(name)
            info.append(info_curr)
        return info

    def test_event(self):
        print("\n\n Select Option for test\n\n")

        counter = 0
        events_list = []
        for event in ALL_EVENTS:
            print(str(counter + 1) + ". test " + event)
            events_list.append(event)
            counter += 1

        print ("{}. return to main menu".format(str(counter+1)))

        input_choice = input("Input between 1 - {}: \n\n>>".format(len(ALL_EVENTS)+ 1))
        if int(input_choice) <= len(ALL_EVENTS):
            TestEventsInterface().test(events_list[int(input_choice)-1])
            if self.do_continue():
                return self.test_event()
        else:
            return self.create_main_event()

    def show_event_info(self):

        print("\n\n Select event to show sample structure.\n\n")
        counter = 2
        events_list = []
        print ("1. Write all events structure to json_file")
        for event in ALL_EVENTS:
            print(str(counter) + ". Structure for " + event)
            counter += 1
            events_list.append(event)

        print("{}. return to main menu".format(str(counter)))

        input_choice = input("Input between 1 - {}: \n\n>> ".format(len(ALL_EVENTS) + 2))
        if int(input_choice) == 1:
            jsonData = {}
            for event in ALL_EVENTS:
                current = TestEventsInterface().get_sample_structure(event)
                jsonData[event] = current

            with open('/Users/jennie/Desktop/ASK_Jennie_automations/jennie/event-structures.json', 'w', encoding='utf-8') as f:
                json.dump(jsonData, f, ensure_ascii=False, indent=4)

            print("Event Structures written in file event-structures.json")
        else:
            if int(input_choice) <= len(ALL_EVENTS):
                TestEventsInterface().show_sample_strcuture(events_list[int(input_choice)-2])
                if self.do_continue():
                    return self.show_event_info()
            else:
                return self.create_main_event()

    def do_continue(self):
        input_choice = input("Press c and enter to cancel: \n\n>>")
        if input_choice.replace(" ", "").lower() == "c":
            return False
        return True