import os, json

class test_event():
    def __init__(self, event_class):
        self.test_level = 1
        self.parent_folder = "/Users/jennie/Desktop/ASK_Jennie_automations/jennie/testproject"
        self.out_folder = "{}/sampleapp".format(self.parent_folder)
        self.testclass = event_class(user_key="1b7dc8923370c2835fbaed3b30cabf10813da87d", app_name="sample-test-application", type="angular-automations")
        status = self.create_project

    @property
    def create_project(self):
        if not os.path.exists(self.out_folder):
            os.chdir(self.parent_folder)
            os.system("ng new sampleapp")
        os.chdir(self.out_folder)
        return True

    @property
    def do_continue(self):
        continue_choice = input("Continue, press c and enter for cancel >> ")
        if continue_choice.lower().replace(" ", "") == "c":
            return False
        return True


    def test_build(self):
        print("\n\nRunning test Build Configuration: for add-ng-library\n\n")
        self.event_info = self.testclass.build_event()
        print("\n\nConfiguration Build : \n\n" + json.dumps(self.event_info, indent=2), "\n\n")
        do_continue = self.do_continue
        return do_continue


    def test_validate(self):
        print("\n\nValidating \n\n : \n\n", json.dumps(self.event_info, indent=2), "\n\n")
        event_info = self.testclass.validate(self.event_info)
        print("\n\nConfiguration Validated : \n\n" + json.dumps(event_info, indent=2), "\n\n")
        do_continue = self.do_continue
        return do_continue

    def test_execute(self):
        print("\n\nExecuting event \n\n{}\n\n".format(json.dumps(self.event_info, indent=2)))
        self.testclass.execute(self.event_info)
        print("\n\nExecuted event in directory : {}\n\n".format(self.out_folder))
        return True

    @property
    def test(self):
        event_info = {}
        if self.test_level < 1:
            print ("\n\ntest_event.py : Error: No Test enable\n\n")
            return False

        if self.test_level > 0:
            do_continue = self.test_build()
            if not do_continue:
                return True

        if self.test_level > 1:
            do_continue = self.test_validate()
            if not do_continue:
                return True

        if self.test_level > 2:
            self.test_execute()

        return True